package com.ruoyi.logistics.mapper;

import java.time.LocalDate;
import java.util.List;
import java.util.Map;

import com.ruoyi.logistics.domain.BizWaybillOrder;
import com.ruoyi.logistics.domain.dto.OrderStatisticsDto;
import com.ruoyi.logistics.domain.dto.DailyOrderStatisticsDto;
import org.apache.ibatis.annotations.Param;

/**
 * 运单管理Mapper接口
 * 
 * @author RuiJing
 * @date 2026-01-29
 */
public interface BizWaybillOrderMapper 
{
    /**
     * 查询运单管理
     * 
     * @param waybillId 运单管理主键
     * @return 运单管理
     */
    public BizWaybillOrder selectBizWaybillOrderByWaybillId(Long waybillId);

    /**
     * 查询运单管理列表
     * 
     * @param bizWaybillOrder 运单管理
     * @return 运单管理集合
     */
    public List<BizWaybillOrder> selectBizWaybillOrderList(BizWaybillOrder bizWaybillOrder);

    /**
     * 新增运单管理
     * 
     * @param bizWaybillOrder 运单管理
     * @return 结果
     */
    public int insertBizWaybillOrder(BizWaybillOrder bizWaybillOrder);

    /**
     * 修改运单管理
     * 
     * @param bizWaybillOrder 运单管理
     * @return 结果
     */
    public int updateBizWaybillOrder(BizWaybillOrder bizWaybillOrder);

    /**
     * 删除运单管理
     * 
     * @param waybillId 运单管理主键
     * @return 结果
     */
    public int deleteBizWaybillOrderByWaybillId(Long waybillId);

    /**
     * 批量删除运单管理
     * 
     * @param waybillIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteBizWaybillOrderByWaybillIds(Long[] waybillIds);

    /**
     * 根据查询条件查询运单详情
     * @param query
     * @return
     */
    public BizWaybillOrder selectBizWaybillOrderByQuery(BizWaybillOrder query);

    void updateBizWaybillOrderState(BizWaybillOrder bizWaybillOrder);


    int canceleBizWaybillOrder(BizWaybillOrder bizWaybillOrder);

    /**
     * 根据订单类型统计订单数量
     *
     * @return 订单统计结果
     */
    OrderStatisticsDto selectTotalOrdersByOrderType(BizWaybillOrder bizWaybillOrder);

    /**
     * 根据日期范围查询订单统计
     *
     * @return 订单统计结果列表
     */
    List<DailyOrderStatisticsDto> selectLast7DaysOrderStatisticsByDateRange(BizWaybillOrder bizWaybillOrder);

    void updateRateByMonthAndDept(Map rateParam);
}
